<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation">
  <fileFormats>
    <output>
        <hdf5 />
      <info/>
    </output>
    <materialData file="mat.xml" format="xml" />
  </fileFormats>

  <domain geometryType="plane">
    <regionList>
      <region material="99lines" name="mech" />
    </regionList>
    <nodeList>
      <nodes name="load">
        <coord x="1" y="0" />
      </nodes>
    </nodeList>
  </domain>

  <sequenceStep index="1">
    <analysis>
      <static/>
    </analysis>

    <pdeList>
      <mechanic subType="planeStress">
        <regionList>
          <region name="mech" />
        </regionList>

        <bcsAndLoads>
           <fix name="west"> 
              <comp dof="x"/> 
              <comp dof="y"/> 
           </fix>
           <force name="load">
             <comp dof="y" value="-1"/>
           </force>
        </bcsAndLoads>

        <storeResults>
          <nodeResult type="mechDisplacement">
            <allRegions/>
          </nodeResult>
          <elemResult type="mechPseudoDensity">
            <allRegions/>
          </elemResult>
          <elemResult type="physicalPseudoDensity">
            <allRegions/>
          </elemResult>
          <elemResult type="mechTensor">
            <allRegions/>
          </elemResult>
          <elemResult type="optResult_1">
            <allRegions/>
          </elemResult>
          <elemResult type="optResult_2">
            <allRegions/>
          </elemResult>
          <elemResult type="optResult_3">
            <allRegions/>
          </elemResult>
          <elemResult type="optResult_4">
            <allRegions/>
          </elemResult>
          <elemResult type="optResult_5">
            <allRegions/>
          </elemResult>
          <elemResult type="optResult_6">
            <allRegions/>
          </elemResult>
        </storeResults>
      </mechanic>
    </pdeList>

   <linearSystems>
      <system>
        <solverList>
          <directLDL/>
        </solverList>
      </system>
    </linearSystems> 
  </sequenceStep>
    
  <optimization>
    <costFunction type="compliance" task="minimize" >
      <stopping queue="999" value="0.001" type="designChange"/>
    </costFunction>

    <constraint type="volume" value="0.4" bound="upperBound" linear="true" mode="constraint" />
    <constraint type="volume" value="0.4" bound="upperBound" linear="true" mode="observation" access="physical"/>

    <optimizer type="python" maxIterations="5">
      <python file="sgp-matlab-simp.py">
        <!-- number of levels of hierarichal parameter grid -->
        <option key="levels" value="3"/>
        <!-- number of samples per grid level -->
        <option key="samples" value="50"/>
        <!-- regularization penalty factor -->
        <option key="pen_filter" value="0.8"/>
        <!-- filter radius for filter matrix in matlab -->
        <option key="rad_filter" value="2.3"/>
        <!-- maximum number of volume bisection steps -->
        <option key="max_bisec" value="50"/>
        <!-- location of matlab sgp file -->
        <option key="matlabFile" value="subproblem_solver.m"/>
        <!-- location of mtimesx directory -->
        <option key="mtimesxDir" value="../mtimesx-master"/>
      </python>
    </optimizer>

    <ersatzMaterial region="mech" material="mechanic" method="paramMat" >
      <paramMat>
        <designMaterials>
          <designMaterial type="density-times-2dtensor">
            <param name="mech_11" value="1.098901"/>
            <param name="mech_22" value="1.098901"/>
            <param name="mech_33" value="0.384615"/>
            <param name="mech_23" value="0"/>
            <param name="mech_13" value="0"/>
            <param name="mech_12" value="0.329670"/>
          </designMaterial>
        </designMaterials>
      </paramMat>
<!--       <filters write_mat_filt="true" use_mat_filt="true"> -->
<!--         <filter neighborhood="maxEdge" value="0.0001" type="density" /> -->
<!--       </filters> -->

      <design name="density" initial="0.4" physical_lower="1e-9" upper="1.0" />

      <transferFunction type="simp" application="mech" param="3.0" design="density"/>
      <export save="all" write="iteration"/>
    </ersatzMaterial>
    <commit mode="forward" stride="1"/>
  </optimization>
</cfsSimulation>


